package com.hai.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class HighDeviceExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public HighDeviceExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andTypeIsNull() {
            addCriterion("`type` is null");
            return (Criteria) this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("`type` is not null");
            return (Criteria) this;
        }

        public Criteria andTypeEqualTo(Integer value) {
            addCriterion("`type` =", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotEqualTo(Integer value) {
            addCriterion("`type` <>", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThan(Integer value) {
            addCriterion("`type` >", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("`type` >=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThan(Integer value) {
            addCriterion("`type` <", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThanOrEqualTo(Integer value) {
            addCriterion("`type` <=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeIn(List<Integer> values) {
            addCriterion("`type` in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotIn(List<Integer> values) {
            addCriterion("`type` not in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeBetween(Integer value1, Integer value2) {
            addCriterion("`type` between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("`type` not between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(Long value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(Long value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(Long value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(Long value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(Long value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(Long value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<Long> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<Long> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(Long value1, Long value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(Long value1, Long value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNull() {
            addCriterion("company_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNotNull() {
            addCriterion("company_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameEqualTo(String value) {
            addCriterion("company_name =", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotEqualTo(String value) {
            addCriterion("company_name <>", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThan(String value) {
            addCriterion("company_name >", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_name >=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThan(String value) {
            addCriterion("company_name <", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("company_name <=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLike(String value) {
            addCriterion("company_name like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotLike(String value) {
            addCriterion("company_name not like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIn(List<String> values) {
            addCriterion("company_name in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotIn(List<String> values) {
            addCriterion("company_name not in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameBetween(String value1, String value2) {
            addCriterion("company_name between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotBetween(String value1, String value2) {
            addCriterion("company_name not between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNull() {
            addCriterion("mer_id is null");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNotNull() {
            addCriterion("mer_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerIdEqualTo(Long value) {
            addCriterion("mer_id =", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotEqualTo(Long value) {
            addCriterion("mer_id <>", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThan(Long value) {
            addCriterion("mer_id >", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mer_id >=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThan(Long value) {
            addCriterion("mer_id <", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThanOrEqualTo(Long value) {
            addCriterion("mer_id <=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdIn(List<Long> values) {
            addCriterion("mer_id in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotIn(List<Long> values) {
            addCriterion("mer_id not in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdBetween(Long value1, Long value2) {
            addCriterion("mer_id between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotBetween(Long value1, Long value2) {
            addCriterion("mer_id not between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andMerNameIsNull() {
            addCriterion("mer_name is null");
            return (Criteria) this;
        }

        public Criteria andMerNameIsNotNull() {
            addCriterion("mer_name is not null");
            return (Criteria) this;
        }

        public Criteria andMerNameEqualTo(String value) {
            addCriterion("mer_name =", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameNotEqualTo(String value) {
            addCriterion("mer_name <>", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameGreaterThan(String value) {
            addCriterion("mer_name >", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameGreaterThanOrEqualTo(String value) {
            addCriterion("mer_name >=", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameLessThan(String value) {
            addCriterion("mer_name <", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameLessThanOrEqualTo(String value) {
            addCriterion("mer_name <=", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameLike(String value) {
            addCriterion("mer_name like", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameNotLike(String value) {
            addCriterion("mer_name not like", value, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameIn(List<String> values) {
            addCriterion("mer_name in", values, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameNotIn(List<String> values) {
            addCriterion("mer_name not in", values, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameBetween(String value1, String value2) {
            addCriterion("mer_name between", value1, value2, "merName");
            return (Criteria) this;
        }

        public Criteria andMerNameNotBetween(String value1, String value2) {
            addCriterion("mer_name not between", value1, value2, "merName");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdIsNull() {
            addCriterion("mer_store_id is null");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdIsNotNull() {
            addCriterion("mer_store_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdEqualTo(Long value) {
            addCriterion("mer_store_id =", value, "merStoreId");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdNotEqualTo(Long value) {
            addCriterion("mer_store_id <>", value, "merStoreId");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdGreaterThan(Long value) {
            addCriterion("mer_store_id >", value, "merStoreId");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mer_store_id >=", value, "merStoreId");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdLessThan(Long value) {
            addCriterion("mer_store_id <", value, "merStoreId");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdLessThanOrEqualTo(Long value) {
            addCriterion("mer_store_id <=", value, "merStoreId");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdIn(List<Long> values) {
            addCriterion("mer_store_id in", values, "merStoreId");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdNotIn(List<Long> values) {
            addCriterion("mer_store_id not in", values, "merStoreId");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdBetween(Long value1, Long value2) {
            addCriterion("mer_store_id between", value1, value2, "merStoreId");
            return (Criteria) this;
        }

        public Criteria andMerStoreIdNotBetween(Long value1, Long value2) {
            addCriterion("mer_store_id not between", value1, value2, "merStoreId");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameIsNull() {
            addCriterion("mer_store_name is null");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameIsNotNull() {
            addCriterion("mer_store_name is not null");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameEqualTo(String value) {
            addCriterion("mer_store_name =", value, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameNotEqualTo(String value) {
            addCriterion("mer_store_name <>", value, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameGreaterThan(String value) {
            addCriterion("mer_store_name >", value, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameGreaterThanOrEqualTo(String value) {
            addCriterion("mer_store_name >=", value, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameLessThan(String value) {
            addCriterion("mer_store_name <", value, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameLessThanOrEqualTo(String value) {
            addCriterion("mer_store_name <=", value, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameLike(String value) {
            addCriterion("mer_store_name like", value, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameNotLike(String value) {
            addCriterion("mer_store_name not like", value, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameIn(List<String> values) {
            addCriterion("mer_store_name in", values, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameNotIn(List<String> values) {
            addCriterion("mer_store_name not in", values, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameBetween(String value1, String value2) {
            addCriterion("mer_store_name between", value1, value2, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andMerStoreNameNotBetween(String value1, String value2) {
            addCriterion("mer_store_name not between", value1, value2, "merStoreName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameIsNull() {
            addCriterion("device_name is null");
            return (Criteria) this;
        }

        public Criteria andDeviceNameIsNotNull() {
            addCriterion("device_name is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceNameEqualTo(String value) {
            addCriterion("device_name =", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameNotEqualTo(String value) {
            addCriterion("device_name <>", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameGreaterThan(String value) {
            addCriterion("device_name >", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameGreaterThanOrEqualTo(String value) {
            addCriterion("device_name >=", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameLessThan(String value) {
            addCriterion("device_name <", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameLessThanOrEqualTo(String value) {
            addCriterion("device_name <=", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameLike(String value) {
            addCriterion("device_name like", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameNotLike(String value) {
            addCriterion("device_name not like", value, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameIn(List<String> values) {
            addCriterion("device_name in", values, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameNotIn(List<String> values) {
            addCriterion("device_name not in", values, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameBetween(String value1, String value2) {
            addCriterion("device_name between", value1, value2, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceNameNotBetween(String value1, String value2) {
            addCriterion("device_name not between", value1, value2, "deviceName");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNull() {
            addCriterion("device_sn is null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNotNull() {
            addCriterion("device_sn is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnEqualTo(String value) {
            addCriterion("device_sn =", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotEqualTo(String value) {
            addCriterion("device_sn <>", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThan(String value) {
            addCriterion("device_sn >", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThanOrEqualTo(String value) {
            addCriterion("device_sn >=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThan(String value) {
            addCriterion("device_sn <", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThanOrEqualTo(String value) {
            addCriterion("device_sn <=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLike(String value) {
            addCriterion("device_sn like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotLike(String value) {
            addCriterion("device_sn not like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIn(List<String> values) {
            addCriterion("device_sn in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotIn(List<String> values) {
            addCriterion("device_sn not in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnBetween(String value1, String value2) {
            addCriterion("device_sn between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotBetween(String value1, String value2) {
            addCriterion("device_sn not between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyIsNull() {
            addCriterion("device_key is null");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyIsNotNull() {
            addCriterion("device_key is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyEqualTo(String value) {
            addCriterion("device_key =", value, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyNotEqualTo(String value) {
            addCriterion("device_key <>", value, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyGreaterThan(String value) {
            addCriterion("device_key >", value, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyGreaterThanOrEqualTo(String value) {
            addCriterion("device_key >=", value, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyLessThan(String value) {
            addCriterion("device_key <", value, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyLessThanOrEqualTo(String value) {
            addCriterion("device_key <=", value, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyLike(String value) {
            addCriterion("device_key like", value, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyNotLike(String value) {
            addCriterion("device_key not like", value, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyIn(List<String> values) {
            addCriterion("device_key in", values, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyNotIn(List<String> values) {
            addCriterion("device_key not in", values, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyBetween(String value1, String value2) {
            addCriterion("device_key between", value1, value2, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceKeyNotBetween(String value1, String value2) {
            addCriterion("device_key not between", value1, value2, "deviceKey");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiIsNull() {
            addCriterion("device_imei is null");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiIsNotNull() {
            addCriterion("device_imei is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiEqualTo(String value) {
            addCriterion("device_imei =", value, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiNotEqualTo(String value) {
            addCriterion("device_imei <>", value, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiGreaterThan(String value) {
            addCriterion("device_imei >", value, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiGreaterThanOrEqualTo(String value) {
            addCriterion("device_imei >=", value, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiLessThan(String value) {
            addCriterion("device_imei <", value, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiLessThanOrEqualTo(String value) {
            addCriterion("device_imei <=", value, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiLike(String value) {
            addCriterion("device_imei like", value, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiNotLike(String value) {
            addCriterion("device_imei not like", value, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiIn(List<String> values) {
            addCriterion("device_imei in", values, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiNotIn(List<String> values) {
            addCriterion("device_imei not in", values, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiBetween(String value1, String value2) {
            addCriterion("device_imei between", value1, value2, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceImeiNotBetween(String value1, String value2) {
            addCriterion("device_imei not between", value1, value2, "deviceImei");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidIsNull() {
            addCriterion("device_iccid is null");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidIsNotNull() {
            addCriterion("device_iccid is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidEqualTo(String value) {
            addCriterion("device_iccid =", value, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidNotEqualTo(String value) {
            addCriterion("device_iccid <>", value, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidGreaterThan(String value) {
            addCriterion("device_iccid >", value, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidGreaterThanOrEqualTo(String value) {
            addCriterion("device_iccid >=", value, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidLessThan(String value) {
            addCriterion("device_iccid <", value, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidLessThanOrEqualTo(String value) {
            addCriterion("device_iccid <=", value, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidLike(String value) {
            addCriterion("device_iccid like", value, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidNotLike(String value) {
            addCriterion("device_iccid not like", value, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidIn(List<String> values) {
            addCriterion("device_iccid in", values, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidNotIn(List<String> values) {
            addCriterion("device_iccid not in", values, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidBetween(String value1, String value2) {
            addCriterion("device_iccid between", value1, value2, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andDeviceIccidNotBetween(String value1, String value2) {
            addCriterion("device_iccid not between", value1, value2, "deviceIccid");
            return (Criteria) this;
        }

        public Criteria andReceiptTopIsNull() {
            addCriterion("receipt_top is null");
            return (Criteria) this;
        }

        public Criteria andReceiptTopIsNotNull() {
            addCriterion("receipt_top is not null");
            return (Criteria) this;
        }

        public Criteria andReceiptTopEqualTo(String value) {
            addCriterion("receipt_top =", value, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopNotEqualTo(String value) {
            addCriterion("receipt_top <>", value, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopGreaterThan(String value) {
            addCriterion("receipt_top >", value, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopGreaterThanOrEqualTo(String value) {
            addCriterion("receipt_top >=", value, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopLessThan(String value) {
            addCriterion("receipt_top <", value, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopLessThanOrEqualTo(String value) {
            addCriterion("receipt_top <=", value, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopLike(String value) {
            addCriterion("receipt_top like", value, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopNotLike(String value) {
            addCriterion("receipt_top not like", value, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopIn(List<String> values) {
            addCriterion("receipt_top in", values, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopNotIn(List<String> values) {
            addCriterion("receipt_top not in", values, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopBetween(String value1, String value2) {
            addCriterion("receipt_top between", value1, value2, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptTopNotBetween(String value1, String value2) {
            addCriterion("receipt_top not between", value1, value2, "receiptTop");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceIsNull() {
            addCriterion("receipt_source is null");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceIsNotNull() {
            addCriterion("receipt_source is not null");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceEqualTo(String value) {
            addCriterion("receipt_source =", value, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceNotEqualTo(String value) {
            addCriterion("receipt_source <>", value, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceGreaterThan(String value) {
            addCriterion("receipt_source >", value, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceGreaterThanOrEqualTo(String value) {
            addCriterion("receipt_source >=", value, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceLessThan(String value) {
            addCriterion("receipt_source <", value, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceLessThanOrEqualTo(String value) {
            addCriterion("receipt_source <=", value, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceLike(String value) {
            addCriterion("receipt_source like", value, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceNotLike(String value) {
            addCriterion("receipt_source not like", value, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceIn(List<String> values) {
            addCriterion("receipt_source in", values, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceNotIn(List<String> values) {
            addCriterion("receipt_source not in", values, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceBetween(String value1, String value2) {
            addCriterion("receipt_source between", value1, value2, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptSourceNotBetween(String value1, String value2) {
            addCriterion("receipt_source not between", value1, value2, "receiptSource");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomIsNull() {
            addCriterion("receipt_bottom is null");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomIsNotNull() {
            addCriterion("receipt_bottom is not null");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomEqualTo(String value) {
            addCriterion("receipt_bottom =", value, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomNotEqualTo(String value) {
            addCriterion("receipt_bottom <>", value, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomGreaterThan(String value) {
            addCriterion("receipt_bottom >", value, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomGreaterThanOrEqualTo(String value) {
            addCriterion("receipt_bottom >=", value, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomLessThan(String value) {
            addCriterion("receipt_bottom <", value, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomLessThanOrEqualTo(String value) {
            addCriterion("receipt_bottom <=", value, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomLike(String value) {
            addCriterion("receipt_bottom like", value, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomNotLike(String value) {
            addCriterion("receipt_bottom not like", value, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomIn(List<String> values) {
            addCriterion("receipt_bottom in", values, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomNotIn(List<String> values) {
            addCriterion("receipt_bottom not in", values, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomBetween(String value1, String value2) {
            addCriterion("receipt_bottom between", value1, value2, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andReceiptBottomNotBetween(String value1, String value2) {
            addCriterion("receipt_bottom not between", value1, value2, "receiptBottom");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}